// -*- C++ -*-
/*!
 * @file  CheckConnect.h
 * @brief Check connect sample component
 * @date  $Date$
 *
 * $Id$
 */

#ifndef CHECKCONNECT_H
#define CHECKCONNECT_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>


#include <string>

using namespace RTC;

class CheckConnect
  : public RTC::DataFlowComponentBase
{
 public:
  CheckConnect(RTC::Manager* manager);
  ~CheckConnect();

  // The initialize action (on CREATED->ALIVE transition)
  // formaer rtc_init_entry() 
 virtual RTC::ReturnCode_t onInitialize();


  // The activated action (Active state entry action)
  // former rtc_active_entry()
  virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);


  /*!
   * @brief find port functor.
   * PortList$B$+$i<+J,$r%]!<%H$r8+IU$1$k$?$a$N%U%!%s%/%?%/%i%9(B
   */
  struct find_port_name
  {
    find_port_name(const char* name) : m_name(name) {};
    bool operator()(const Port_ptr& p)
    {
      std::string name(p->get_port_profile()->name);
      return m_name == name;
    }
    const std::string m_name;
  };
  

 protected:
  // DataInPort declaration
  TimedLong m_ref;
  InPort<TimedLong> m_refIn;
  

  // DataOutPort declaration
  TimedLong m_vel;
  OutPort<TimedLong> m_velOut;
  

 private:
  int dummy;

};


extern "C"
{
  void CheckConnectInit(RTC::Manager* manager);
};

#endif // CHECKCONNECT_H
